Xerces-C++: EntityResolver Class Reference

Xerces-C++ 3.1.4

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

List of all members
EntityResolver Class Referenceabstract

Basic interface for resolving entities. More...

Inheritance diagram for EntityResolver:

## Public Member Functions
Constructors and Destructor
| EntityResolver ()
| Default Constructor. More...
virtual | ~EntityResolver ()
| Destructor. More...
The EntityResolver interface
virtual InputSource * | resolveEntity (const XMLCh *const publicId, const XMLCh *const systemId)=0
| Allow the application to resolve external entities. More...

## Detailed Description

Basic interface for resolving entities.

If a SAX application needs to implement customized handling for external entities, it must implement this interface and register an instance with the SAX parser using the parser's setEntityResolver method.

The parser will then allow the application to intercept any external entities (including the external DTD subset and external parameter entities, if any) before including them.

Many SAX applications will not need to implement this interface, but it will be especially useful for applications that build XML documents from databases or other specialised input sources, or for applications that use URI types other than URLs.

The following resolver would provide the application with a special character stream for the entity with the system identifier "http://www.myhost.com/today":

`#include <xercesc/sax/EntityResolver.hpp>
#include <xercesc/sax/InputSource.hpp>
class MyResolver : public EntityResolver {
public:
InputSource resolveEntity (const XMLCh* const publicId, const XMLCh* const systemId);
...
};
MyResolver::resolveEntity {
if (XMLString::compareString(systemId, "http://www.myhost.com/today")) {
MyReader* reader = new MyReader();
return new InputSource(reader);
} else {
return null;
}
}
`

The application can also use this interface to redirect system identifiers to local URIs or to look up replacements in a catalog (possibly by using the public identifier).

The HandlerBase class implements the default behaviour for this interface, which is simply always to return null (to request that the parser use the default system identifier).

See Also
  Parser::setEntityResolver
  InputSource::InputSource
  HandlerBase::HandlerBase

## Constructor & Destructor Documentation

EntityResolver::EntityResolver | ( |  | ) |

Default Constructor.

virtual EntityResolver::~EntityResolver | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

virtual InputSource* EntityResolver::resolveEntity | ( | const XMLCh *const | publicId,
|  | const XMLCh *const | systemId
| ) |  |
| pure virtual

Allow the application to resolve external entities.

The Parser will call this method before opening any external entity except the top-level document entity (including the external DTD subset, external entities referenced within the DTD, and external entities referenced within the document element): the application may request that the parser resolve the entity itself, that it use an alternative URI, or that it use an entirely different input source.

Application writers can use this method to redirect external system identifiers to secure and/or local URIs, to look up public identifiers in a catalogue, or to read an entity from a database or other input source (including, for example, a dialog box).

If the system identifier is a URL, the SAX parser must resolve it fully before reporting it to the application.

Parameters

  publicId | The public identifier of the external entity being referenced, or null if none was supplied.
  systemId | The system identifier of the external entity being referenced.

Returns
  An InputSource object describing the new input source, or null to request that the parser open a regular URI connection to the system identifier. The returned InputSource is owned by the parser which is responsible to clean up the memory.

Exceptions

  SAXException | Any SAX exception, possibly wrapping another exception.
  IOException | An IO exception, possibly the result of creating a new InputStream or Reader for the InputSource.

See Also
  InputSource::InputSource

Implemented in DefaultHandler, and HandlerBase.

The documentation for this class was generated from the following file:

- EntityResolver.hpp